# PIG Pilot (Sound manager)
# Copyright (C) 2005  Robin J Patenall
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
#

# Basic system imports
import sys

# Pygame imports
import pygame

# The dictionary of sounds.
sounds = {}

# Play the supplied sound
# If I get time I'll make this run better by properly prioritising the sounds.
def play(filename) :
  
  # Allow me to access the sounds info
  global sounds
  
  # If there isn't an entry in the dictionary for the sound ...
  if sounds.get(filename) == None : 
    
    # ... load the sound
    sound = sounds[filename] = pygame.mixer.Sound(filename)
  else :
    
    # Get the sound reference.
    sound = sounds[filename]

  # Play the sound. If it couldn't be played ...
  if sound.play() == None :
    
    # ... find an empty channel of the one with the oldest sound ...
    channel = pygame.mixer.find_channel(True)
    
    # ... and stop the sound playing on it.
    if channel != None :
      channel.stop()
    
    # Try to play the sound again.
    sound.play()
